Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1761)
+++ palm/trunk/SOURCE/Makefile	(revision 1762)
@@ -20,5 +20,5 @@
 # Current revisions:
 # ------------------
-# 
+# +pmc_interface, +pmc routines
 # 
 # Former revisions:
@@ -245,5 +245,8 @@
 	ls_forcing.f90 message.f90 microphysics.f90 modules.f90 mod_kinds.f90 \
 	mod_particle_attributes.f90 netcdf.f90 nudging.f90 package_parin.f90 \
-	palm.f90 parin.f90 plant_canopy_model.f90 poisfft.f90 poismg.f90 \
+	palm.f90 parin.f90 plant_canopy_model.f90 pmc_interface.f90 \
+	pmc_client.f90 pmc_general.f90 pmc_handle_communicator.f90 pmc_mpi_wrapper.f90 \
+	pmc_server.f90 \
+	poisfft.f90 poismg.f90 \
 	poismg_fast.f90 pres.f90 print_1d.f90 production_e.f90 \
 	prognostic_equations.f90 progress_bar.f90 radiation_model.f90 \
@@ -371,5 +374,5 @@
 init_masks.o: modules.o mod_kinds.o
 init_ocean.o: modules.o eqn_state_seawater.o mod_kinds.o
-init_pegrid.o: modules.o mod_kinds.o
+init_pegrid.o: modules.o mod_kinds.o pmc_interface.o
 init_pt_anomaly.o: modules.o mod_kinds.o
 init_rankine.o: modules.o mod_kinds.o
@@ -423,7 +426,13 @@
                  plant_canopy_model.o radiation_model.o
 palm.o: modules.o cpulog.o ls_forcing.o mod_kinds.o nudging.o\
-	 surface_layer_fluxes.o
+	pmc_interface.o surface_layer_fluxes.o
 parin.o: modules.o cpulog.o mod_kinds.o progress_bar.o
 plant_canopy_model.o: modules.o mod_kinds.o
+pmc_interface.o: modules.o mod_kinds.o pmc_client.o pmc_general.o\
+	pmc_handle_communicator.o pmc_mpi_wrapper.o pmc_server.o
+pmc_client.o: pmc_general.o pmc_handle_communicator.o pmc_mpi_wrapper.o
+pmc_handle_communicator.o: pmc_general.o
+pmc_mpi_wrapper.o: pmc_handle_communicator.o
+pmc_server.o: pmc_general.o pmc_handle_communicator.o pmc_mpi_wrapper.o
 poisfft.o: modules.o cpulog.o fft_xy.o mod_kinds.o tridia_solver.o
 poismg.o: modules.o cpulog.o mod_kinds.o
@@ -461,5 +470,5 @@
 time_integration.o: modules.o advec_ws.o buoyancy.o calc_mean_profile.o \
 	cpulog.o interaction_droplets_ptq.o land_surface_model.o \
-	ls_forcing.o mod_kinds.o nudging.o production_e.o \
+	ls_forcing.o mod_kinds.o nudging.o pmc_interface.o production_e.o \
 	prognostic_equations.o progress_bar.o radiation_model.o \
 	 user_actions.o surface_layer_fluxes.o
Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 1761)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-!
+! Introduction of nested domain feature
 !
 ! Former revisions:
@@ -134,8 +134,8 @@
                ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, ibc_sa_t, ibc_uv_b,       &
                ibc_uv_t, icloud_scheme, inflow_l, inflow_n, inflow_r, inflow_s,&
-               intermediate_timestep_count, large_scale_forcing, ocean,        &
+               intermediate_timestep_count, large_scale_forcing, nest_domain,  &
+               nest_bound_l, nest_bound_s, nudging, ocean,                     &
                outflow_l, outflow_n, outflow_r, outflow_s, passive_scalar,     &
-               precipitation, tsc, use_cmax, &
-               nudging
+               precipitation, tsc, use_cmax
 
     USE grid_variables,                                                        &
@@ -179,5 +179,5 @@
 
 !
-!-- Top boundary
+!-- Top boundary. A nested domain ( ibc_uv_t = 3 ) does not require settings.
     IF ( ibc_uv_t == 0 )  THEN
        !$acc kernels present( u_init, u_p, v_init, v_p )
@@ -185,5 +185,5 @@
         v_p(nzt+1,:,:) = v_init(nzt+1)
        !$acc end kernels
-    ELSE
+    ELSEIF ( ibc_uv_t == 1 )  THEN
        !$acc kernels present( u_p, v_p )
         u_p(nzt+1,:,:) = u_p(nzt,:,:)
@@ -191,7 +191,10 @@
        !$acc end kernels
     ENDIF
-    !$acc kernels present( w_p )
-    w_p(nzt:nzt+1,:,:) = 0.0_wp  ! nzt is not a prognostic level (but cf. pres)
-    !$acc end kernels
+
+    IF ( .NOT. nest_domain )  THEN
+       !$acc kernels present( w_p )
+       w_p(nzt:nzt+1,:,:) = 0.0_wp  ! nzt is not a prognostic level (but cf. pres)
+       !$acc end kernels
+    ENDIF
 
 !
@@ -255,5 +258,7 @@
           ENDDO
        ENDDO
-       e_p(nzt+1,:,:) = e_p(nzt,:,:)
+       IF ( .NOT. nest_domain )  THEN
+          e_p(nzt+1,:,:) = e_p(nzt,:,:)
+       ENDIF
        !$acc end kernels
     ENDIF
@@ -325,8 +330,9 @@
     ENDIF
 !
-!-- In case of inflow at the south boundary the boundary for v is at nys
-!-- and in case of inflow at the left boundary the boundary for u is at nxl.
-!-- Since in prognostic_equations (cache optimized version) these levels are
-!-- handled as a prognostic level, boundary values have to be restored here.
+!-- In case of inflow or nest boundary at the south boundary the boundary for v
+!-- is at nys and in case of inflow or nest boundary at the left boundary the
+!-- boundary for u is at nxl. Since in prognostic_equations (cache optimized
+!-- version) these levels are handled as a prognostic level, boundary values
+!-- have to be restored here.
 !-- For the SGS-TKE, Neumann boundary conditions are used at the inflow.
     IF ( inflow_s )  THEN
@@ -340,4 +346,16 @@
     ELSEIF ( inflow_r )  THEN
        IF ( .NOT. constant_diffusion ) e_p(:,:,nxr+1) = e_p(:,:,nxr)
+    ENDIF
+
+!
+!-- The same restoration for u at i=nxl and v at j=nys as above must be made
+!-- in case of nest boundaries. Note however, that the above ELSEIF-structure is
+!-- not appropriate here as there may be more than one nest boundary on a
+!-- PE-domain. Furthermore Neumann conditions for SGS-TKE are not required here.
+    IF ( nest_bound_s )  THEN
+       v_p(:,nys,:) = v_p(:,nys-1,:)
+    ENDIF
+    IF ( nest_bound_l )  THEN
+       u_p(:,:,nxl) = u_p(:,:,nxl-1)
     ENDIF
 
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1761)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! Previous version restored.
+! Introduction of nested domain feature
 ! 
 ! Former revisions:
@@ -1755,5 +1755,5 @@
 !-- Lateral boundary conditions
     IF ( bc_lr /= 'cyclic'  .AND.  bc_lr /= 'dirichlet/radiation'  .AND. &
-         bc_lr /= 'radiation/dirichlet' )  THEN
+         bc_lr /= 'radiation/dirichlet'  .AND.  bc_lr /= 'nested' )  THEN
        message_string = 'unknown boundary condition: bc_lr = "' // &
                         TRIM( bc_lr ) // '"'
@@ -1761,5 +1761,5 @@
     ENDIF
     IF ( bc_ns /= 'cyclic'  .AND.  bc_ns /= 'dirichlet/radiation'  .AND. &
-         bc_ns /= 'radiation/dirichlet' )  THEN
+         bc_ns /= 'radiation/dirichlet'  .AND.  bc_ns /= 'nested' )  THEN
        message_string = 'unknown boundary condition: bc_ns = "' // &
                         TRIM( bc_ns ) // '"'
@@ -1843,5 +1843,6 @@
     IF ( bc_p_t == 'dirichlet' )  THEN
        ibc_p_t = 0
-    ELSEIF ( bc_p_t == 'neumann' )  THEN
+!-- TO_DO: later set bc_p_t to neumann before, in case of nested domain
+    ELSEIF ( bc_p_t == 'neumann' .OR. bc_p_t == 'nested' )  THEN
        ibc_p_t = 1
     ELSE
@@ -1873,4 +1874,6 @@
     ELSEIF ( bc_pt_t == 'initial_gradient' )  THEN
        ibc_pt_t = 2
+    ELSEIF ( bc_pt_t == 'nested' )  THEN
+       ibc_pt_t = 3
     ELSE
        message_string = 'unknown boundary condition: bc_pt_t = "' // &
@@ -2015,4 +2018,6 @@
        ELSEIF ( bc_q_t == 'neumann' )  THEN
           ibc_q_t = 1
+       ELSEIF ( bc_q_t == 'nested' )  THEN
+          ibc_q_t = 3
        ELSE
           message_string = 'unknown boundary condition: bc_' // TRIM( sq ) // &
@@ -2098,4 +2103,6 @@
        ELSEIF ( bc_uv_t == 'neumann' )  THEN
           ibc_uv_t = 1
+       ELSEIF ( bc_uv_t == 'nested' )  THEN
+          ibc_uv_t = 3
        ELSE
           message_string = 'unknown boundary condition: bc_uv_t = "' // &
@@ -3861,6 +3868,5 @@
        ntdim_2d_xz(1) = ntdim_3d(1)
        ntdim_2d_yz(1) = ntdim_3d(1)
-             write(9,*) "ntdim_3d(av)=",ntdim_3d(0)
-             CALL local_flush(9)
+
     ENDIF
 
Index: palm/trunk/SOURCE/exchange_horiz_2d.f90
===================================================================
--- palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 1761)
+++ palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Introduction of nested domain feature
 ! 
 ! Former revisions:
@@ -62,4 +62,5 @@
     USE control_parameters,                                                    &
         ONLY :  bc_lr_cyc, bc_ns_cyc, inflow_l, inflow_n, inflow_r, inflow_s,  &
+                nest_bound_l, nest_bound_n, nest_bound_r, nest_bound_s,        &
                 outflow_l, outflow_n, outflow_r, outflow_s
                 
@@ -153,26 +154,26 @@
 
 !
-!-- Neumann-conditions at inflow/outflow in case of non-cyclic boundary
-!-- conditions
-    IF ( inflow_l .OR. outflow_l )  THEN
-       DO i=nbgp, 1, -1
+!-- Neumann-conditions at inflow/outflow/nested boundaries
+    IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
+       DO  i = nbgp, 1, -1
          ar(:,nxl-i) = ar(:,nxl)
-       END DO
-    END IF
-    IF ( inflow_r .OR. outflow_r )  THEN 
-       DO i=1, nbgp
+       ENDDO
+    ENDIF
+    IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
+       DO  i = 1, nbgp
           ar(:,nxr+i) = ar(:,nxr)
-       END DO
-    END IF
-    IF ( inflow_s .OR. outflow_s )  THEN
-       DO i=nbgp, 1, -1
+       ENDDO
+    ENDIF
+    IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
+       DO  i = nbgp, 1, -1
          ar(nys-i,:) = ar(nys,:)
-       END DO
-    END IF
-    IF ( inflow_n .OR. outflow_n )  THEN
-       DO i=1, nbgp
+       ENDDO
+    ENDIF
+    IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
+       DO  i = 1, nbgp
          ar(nyn+i,:) = ar(nyn,:)
-       END DO
-    END IF
+       ENDDO
+    ENDIF
+
     CALL cpu_log( log_point_s(13), 'exchange_horiz_2d', 'stop' )
 
@@ -193,5 +194,6 @@
 
     USE control_parameters,                                                    &
-        ONLY:  bc_lr_cyc, bc_ns_cyc
+        ONLY:  bc_lr_cyc, bc_ns_cyc, nest_bound_l, nest_bound_n, nest_bound_r, &
+               nest_bound_s
         
     USE cpulog,                                                                &
@@ -207,4 +209,5 @@
     IMPLICIT NONE
 
+    INTEGER(iwp) ::  i
     INTEGER(iwp) ::  ar(nysg:nyng,nxlg:nxrg)  !<
 
@@ -277,4 +280,27 @@
 
 #endif
+!
+!-- Neumann-conditions at inflow/outflow/nested boundaries
+    IF ( nest_bound_l )  THEN
+       DO  i = nbgp, 1, -1
+         ar(:,nxl-i) = ar(:,nxl)
+       ENDDO
+    ENDIF
+    IF ( nest_bound_r )  THEN
+       DO  i = 1, nbgp
+          ar(:,nxr+i) = ar(:,nxr)
+       ENDDO
+    ENDIF
+    IF ( nest_bound_s )  THEN
+       DO  i = nbgp, 1, -1
+         ar(nys-i,:) = ar(nys,:)
+       ENDDO
+    ENDIF
+    IF ( nest_bound_n )  THEN
+       DO  i = 1, nbgp
+         ar(nyn+i,:) = ar(nyn,:)
+       ENDDO
+    ENDIF
+
     CALL cpu_log( log_point_s(13), 'exchange_horiz_2d', 'stop' )
 
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1761)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-!
+! Introduction of nested domain feature
 !
 ! Former revisions:
@@ -669,6 +669,9 @@
 !-- is done). Further below the values needed within the timestep scheme
 !-- will be set.
+!-- TO_DO: zeroth element added to weight_pres because in case of nesting
+!--        pres may need to be called  outside the RK-substeps. Antti will
+!--        check if this is really required.
     ALLOCATE( weight_substep(1:intermediate_timestep_count_max), &
-              weight_pres(1:intermediate_timestep_count_max) )
+              weight_pres(0:intermediate_timestep_count_max) )
     weight_substep = 1.0_wp
     weight_pres    = 1.0_wp
@@ -774,7 +777,8 @@
 
 !
+!--       Inside buildings set velocities back to zero
           IF ( topography /= 'flat' )  THEN
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    u(nzb:nzb_u_inner(j,i),j,i) = 0.0_wp
                    v(nzb:nzb_v_inner(j,i),j,i) = 0.0_wp
@@ -841,12 +845,13 @@
 !--       in the limiting formula!). The original values are stored to be later
 !--       used for volume flow control.
-          IF ( ibc_uv_b /= 1 )  THEN    
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   u(nzb:nzb_u_inner(j,i)+1,j,i) = 0.0_wp
-                   v(nzb:nzb_v_inner(j,i)+1,j,i) = 0.0_wp
-                ENDDO
-             ENDDO
-          ENDIF
+          ! TO_DO:  Antti will check if this is really required
+          !AH IF ( ibc_uv_b /= 1 )  THEN
+          !AH    DO  i = nxlg, nxrg
+          !AH       DO  j = nysg, nyng
+          !AH          u(nzb:nzb_u_inner(j,i)+1,j,i) = 0.0_wp
+          !AH          v(nzb:nzb_v_inner(j,i)+1,j,i) = 0.0_wp
+          !AH       ENDDO
+          !AH    ENDDO
+          !AH ENDIF
 
           IF ( humidity  .OR.  passive_scalar )  THEN
@@ -1669,5 +1674,8 @@
 !
 !-- Setting weighting factors for calculation of perturbation pressure 
-!-- and turbulent quantities from the RK substeps                
+!-- and turbulent quantities from the RK substeps
+!-- TO_DO: zeroth element is added to weight_pres because in nesting pres
+!--        may need to be called outside the RK-substeps
+    weight_pres(0) = 1.0_wp
     IF ( TRIM(timestep_scheme) == 'runge-kutta-3' )  THEN      ! for RK3-method
 
Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 1761)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Introduction of nested domain feature
 !
 ! Former revisions:
@@ -156,6 +156,7 @@
                io_group, inflow_l, inflow_n, inflow_r, inflow_s,               &
                masking_method, maximum_grid_level, message_string,             &
-               momentum_advec, ocean, outflow_l, outflow_n, outflow_r,         &
-               outflow_s, psolver, scalar_advec, topography,                   &
+               momentum_advec, nest_domain, nest_bound_l, nest_bound_n,        &
+               nest_bound_r, nest_bound_s, ocean, outflow_l, outflow_n,        &
+               outflow_r, outflow_s, psolver, scalar_advec, topography,        &
                topography_grid_convention, use_surface_fluxes, use_top_fluxes, &
                wall_adjustment_factor 
@@ -734,6 +735,8 @@
     nzb_max = MAXVAL( nzb_local ) + 1
     IF ( inflow_l .OR. outflow_l .OR. inflow_r .OR. outflow_r .OR.             &
-         inflow_n .OR. outflow_n .OR. inflow_s .OR. outflow_s )  THEN
-         nzb_max = nzt
+         inflow_n .OR. outflow_n .OR. inflow_s .OR. outflow_s .OR.             &
+         nest_domain )                                                         &
+    THEN
+       nzb_max = nzt
     ENDIF
 
@@ -1221,12 +1224,18 @@
 !--             scalar - x-direction
 !--             WS1 (0), WS3 (1), WS5 (2)
-                IF ( k <= nzb_s_inner(j,i+1) .OR. ( ( inflow_l .OR. outflow_l )&
-                     .AND. i == nxl ) .OR. ( ( inflow_r .OR. outflow_r )       &
-                     .AND. i == nxr ) )  THEN
+                IF ( k <= nzb_s_inner(j,i+1) .OR.                              &
+                         ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )       &
+                           .AND. i == nxl   )    .OR.                          &
+                         ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )       &
+                           .AND. i == nxr   ) )                                &
+                THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 0 )
                 ELSEIF ( k <= nzb_s_inner(j,i+2) .OR. k <= nzb_s_inner(j,i-1)  &
-                         .OR. ( ( inflow_r .OR. outflow_r ) .AND. i == nxr-1 ) &
-                         .OR. ( ( inflow_l .OR. outflow_l ) .AND. i == nxlu  ) &
-                       )  THEN
+                                                 .OR.                          &
+                         ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )       &
+                           .AND. i == nxr-1 )    .OR.                          &
+                         ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )       &
+                           .AND. i == nxlu  ) )                                &
+                THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 1 )
                 ELSE
@@ -1236,14 +1245,22 @@
 !--             scalar - y-direction
 !--             WS1 (3), WS3 (4), WS5 (5)
-                IF ( k <= nzb_s_inner(j+1,i) .OR. ( ( inflow_s .OR. outflow_s )&
-                     .AND. j == nys ) .OR. ( ( inflow_n .OR. outflow_n )       &
-                     .AND. j == nyn ) )  THEN
+                IF ( k <= nzb_s_inner(j+1,i) .OR.                              &
+                         ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )       &
+                           .AND. j == nys   )    .OR.                          &
+                         ( ( inflow_n .OR. outflow_n .OR. nest_bound_n )       &
+                           .AND. j == nyn   ) )                                &
+                THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 3 )
+!
 !--             WS3
                 ELSEIF ( k <= nzb_s_inner(j+2,i) .OR. k <= nzb_s_inner(j-1,i)  &
-                         .OR. ( ( inflow_s .OR. outflow_s ) .AND. j == nysv  ) &
-                         .OR. ( ( inflow_n .OR. outflow_n ) .AND. j == nyn-1 ) &
-                       )  THEN
+                                                 .OR.                          &
+                         ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )       &
+                           .AND. j == nysv  )    .OR.                          &
+                         ( ( inflow_n .OR. outflow_n .OR. nest_bound_n )       &
+                           .AND. j == nyn-1 ) )                                &
+                THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 4 )
+!
 !--             WS5
                 ELSE
@@ -1287,13 +1304,18 @@
 !--             u component - x-direction
 !--             WS1 (9), WS3 (10), WS5 (11)
-                IF ( k <= nzb_u_inner(j,i+1)                                  &
-                     .OR. ( ( inflow_l .OR. outflow_l ) .AND. i <= nxlu )     &
-                     .OR. ( ( inflow_r .OR. outflow_r ) .AND. i == nxr  )     &
-                   )  THEN
+                IF ( k <= nzb_u_inner(j,i+1) .OR.                              &
+                         ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )       &
+                           .AND. i <= nxlu  )    .OR.                          &
+                         ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )       &
+                           .AND. i == nxr   ) )                                &
+                THEN
                     wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 9 )
-                ELSEIF ( k <= nzb_u_inner(j,i+2) .OR. k <= nzb_u_inner(j,i-1) &
-                         .OR. ( ( inflow_r .OR. outflow_r ) .AND. i == nxr-1 )&
-                         .OR. ( ( inflow_l .OR. outflow_l ) .AND. i == nxlu+1)&
-                       )  THEN
+                ELSEIF ( k <= nzb_u_inner(j,i+2) .OR. k <= nzb_u_inner(j,i-1)  &
+                                                 .OR.                          &
+                         ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )       &
+                           .AND. i == nxr-1 )    .OR.                          &
+                         ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )       &
+                           .AND. i == nxlu+1) )                                &
+                THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 10 )
 !
@@ -1309,12 +1331,18 @@
 !--             u component - y-direction
 !--             WS1 (12), WS3 (13), WS5 (14)
-                IF ( k <= nzb_u_inner(j+1,i) .OR. ( ( inflow_s .OR. outflow_s )&
-                     .AND. j == nys ) .OR. ( ( inflow_n .OR. outflow_n )       &
-                     .AND. j == nyn ) )  THEN
-                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 12 )
+                IF ( k <= nzb_u_inner(j+1,i) .OR.                              &
+                         ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )       &
+                           .AND. j == nys   )    .OR.                          &
+                         ( ( inflow_n .OR. outflow_n .OR. nest_bound_n )       &
+                           .AND. j == nyn   ) )                                &
+                THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 12 )
                 ELSEIF ( k <= nzb_u_inner(j+2,i) .OR. k <= nzb_u_inner(j-1,i)  &
-                         .OR. ( ( inflow_s .OR. outflow_s ) .AND. j == nysv  ) &
-                         .OR. ( ( inflow_n .OR. outflow_n ) .AND. j == nyn-1 ) &
-                       )  THEN
+                                                 .OR.                          &
+                         ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )       &
+                           .AND. j == nysv  )    .OR.                          &
+                         ( ( inflow_n .OR. outflow_n .OR. nest_bound_n )       &
+                           .AND. j == nyn-1 ) )                                &
+                THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 13 )
 !
@@ -1357,13 +1385,20 @@
 !--             v component - x-direction
 !--             WS1 (18), WS3 (19), WS5 (20)
-                IF ( k <= nzb_v_inner(j,i+1) .OR. ( ( inflow_l .OR. outflow_l )&
-                     .AND. i == nxl ) .OR. (( inflow_r .OR. outflow_r )        &
-                     .AND. i == nxr ) )  THEN
-                     wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 18 )
+                IF ( k <= nzb_v_inner(j,i+1) .OR.                              &
+                         ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )       &
+                           .AND. i == nxl   )    .OR.                          &
+                         ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )       &
+                           .AND. i == nxr   ) )                                &
+                THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 18 )
+!
 !--             WS3
                 ELSEIF ( k <= nzb_v_inner(j,i+2) .OR. k <= nzb_v_inner(j,i-1)  &
-                         .OR. ( ( inflow_r .OR. outflow_r ) .AND. i == nxr-1 ) &
-                         .OR. ( ( inflow_l .OR. outflow_l ) .AND. i == nxlu  ) &
-                       )  THEN
+                                                 .OR.                          &
+                         ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )       &
+                           .AND. i == nxr-1 )    .OR.                          &
+                         ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )       &
+                           .AND. i == nxlu  ) )                                &
+                THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 19 )
 !
@@ -1379,13 +1414,18 @@
 !--             v component - y-direction
 !--             WS1 (21), WS3 (22), WS5 (23)
-                IF ( k <= nzb_v_inner(j+1,i)                                   &
-                     .OR. ( ( inflow_s .OR. outflow_s ) .AND. j <= nysv )      &
-                     .OR. ( ( inflow_n .OR. outflow_n ) .AND. j == nyn  )      &
-                   )  THEN
-                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 21 )
+                IF ( k <= nzb_v_inner(j+1,i) .OR.                              &
+                         ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )       &
+                           .AND. j <= nysv  )    .OR.                          &
+                         ( ( inflow_n .OR. outflow_n .OR. nest_bound_n )       &
+                           .AND. j == nyn   ) )                                &
+                THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 21 )
                 ELSEIF ( k <= nzb_v_inner(j+2,i) .OR. k <= nzb_v_inner(j-1,i)  &
-                         .OR. ( ( inflow_s .OR. outflow_s ) .AND. j == nysv+1 )&
-                         .OR. ( ( inflow_n .OR. outflow_n ) .AND. j == nyn-1  )&
-                       )  THEN
+                                                 .OR.                          &
+                         ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )       &
+                           .AND. j == nysv+1)    .OR.                          &
+                         ( ( inflow_n .OR. outflow_n .OR. nest_bound_n )       &
+                           .AND. j == nyn-1 ) )                                &
+                THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 22 )
 !
@@ -1427,12 +1467,18 @@
 !--             w component - x-direction
 !--             WS1 (27), WS3 (28), WS5 (29)
-                IF ( k <= nzb_w_inner(j,i+1) .OR. ( ( inflow_l .OR. outflow_l )&
-                     .AND. i == nxl ) .OR. ( ( inflow_r .OR. outflow_r )       &
-                     .AND. i == nxr ) )  THEN
-                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 27 )
+                IF ( k <= nzb_w_inner(j,i+1) .OR.                              &
+                         ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )       &
+                           .AND. i == nxl   )    .OR.                          &
+                         ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )       &
+                           .AND. i == nxr   ) )                                &
+                THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 27 )
                 ELSEIF ( k <= nzb_w_inner(j,i+2) .OR. k <= nzb_w_inner(j,i-1)  &
-                         .OR. ( ( inflow_r .OR. outflow_r ) .AND. i == nxr-1 ) &
-                         .OR. ( ( inflow_l .OR. outflow_l ) .AND. i == nxlu  ) &
-                       )  THEN
+                                                 .OR.                          &
+                         ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )       &
+                           .AND. i == nxr-1 )    .OR.                          &
+                         ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )       &
+                           .AND. i == nxlu  ) )                                &
+                THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 28 )
 !
@@ -1448,12 +1494,18 @@
 !--             w component - y-direction
 !--             WS1 (30), WS3 (31), WS5 (32)
-                IF ( k <= nzb_w_inner(j+1,i) .OR. ( ( inflow_s .OR. outflow_s )&
-                     .AND. j == nys ) .OR. ( ( inflow_n .OR. outflow_n )       &
-                     .AND. j == nyn ) )  THEN
-                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 30 )
+                IF ( k <= nzb_w_inner(j+1,i) .OR.                              &
+                         ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )       &
+                           .AND. j == nys   )    .OR.                          &
+                         ( ( inflow_n .OR. outflow_n .OR. nest_bound_n )       &
+                           .AND. j == nyn   ) )                                &
+                THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 30 )
                 ELSEIF ( k <= nzb_w_inner(j+2,i) .OR. k <= nzb_w_inner(j-1,i)  &
-                         .OR. ( ( inflow_s .OR. outflow_s ) .AND. j == nysv  ) &
-                         .OR. ( ( inflow_n .OR. outflow_n ) .AND. j == nyn-1 ) &
-                       )  THEN
+                                                 .OR.                          &
+                         ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )       &
+                           .AND. j == nysv  )    .OR.                          &
+                         ( ( inflow_n .OR. outflow_n .OR. nest_bound_n )       &
+                           .AND. j == nyn-1 ) )                                &
+                THEN
                    wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 31 )
 !
@@ -1504,20 +1556,20 @@
 !--    Set boundary flags at inflow and outflow boundary in case of 
 !--    non-cyclic boundary conditions.
-       IF ( inflow_l .OR. outflow_l )  THEN
+       IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
           wall_flags_0(:,:,nxl-1)  = wall_flags_0(:,:,nxl)
           wall_flags_00(:,:,nxl-1) = wall_flags_00(:,:,nxl)
        ENDIF
 
-       IF ( inflow_r .OR. outflow_r )  THEN
+       IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
           wall_flags_0(:,:,nxr+1)  = wall_flags_0(:,:,nxr)
           wall_flags_00(:,:,nxr+1) = wall_flags_00(:,:,nxr)
        ENDIF
 
-       IF ( inflow_n .OR. outflow_n )  THEN
+       IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
           wall_flags_0(:,nyn+1,:)  = wall_flags_0(:,nyn,:)
           wall_flags_00(:,nyn+1,:) = wall_flags_00(:,nyn,:)
        ENDIF
 
-       IF ( inflow_s .OR. outflow_s )  THEN
+       IF ( inflow_s .OR. outflow_s  .OR. nest_bound_s )  THEN
           wall_flags_0(:,nys-1,:)  = wall_flags_0(:,nys,:)
           wall_flags_00(:,nys-1,:) = wall_flags_00(:,nys,:)
